<?php

class nc_Files extends nc_System {
  public function __construct () {
    // load parent constructor
    parent::__construct();
  }

  public function create_dir ( $fullpath ) {
    $nc_core = nc_Core::get_object();
  
    if ( is_dir($fullpath) ) return true;

    if ( ($res = mkdir($fullpath, $nc_core->DIRCHMOD, 1)) ) {
      chmod($fullpath, $nc_core->DIRCHMOD);
    }

    return $res;
  }

  public function delete_dir ( $path ) {
    if ( !file_exists($path) || !is_dir($path) )  return false;

    if ( !is_writable($path) ) throw new nc_Exception_Files_Not_Rights ($path);

     foreach (scandir($path) as $v) {
       if ($v == "." ||  $v == "..") continue;

       if (filetype($path."/".$v) == "dir") {
         $this->delete_dir($path."/".$v);
       }
       else {
         if ( !is_writable($path."/".$v) ) throw new nc_Exception_Files_Not_Rights ($path."/".$v);
         unlink($path."/".$v);
       }
     }

     rmdir( $path );

     return true;
  }
}

?>
